/*
*  Border
*  ------
*/

package org.remote.frederik.ziege;

import java.awt.*;


public final class Border extends Panel {

	private int borderWidth;

public Border(Component comp) {

	this(comp, 3);

}

public Border(Component comp, int width) {

	borderWidth = width;
	setLayout(new GridLayout(1,1));
	add(comp);
	validate();
}

public Insets getInsets() {

	return(new Insets(borderWidth+1,borderWidth+1,borderWidth+2,borderWidth+2));

}

public void paint(Graphics g) {

	Dimension d = getSize();
	Color bg = getBackground();
	g.setColor(bg);
	g.draw3DRect(0, 0, d.width - 1, d.height - 1, true);
	g.draw3DRect(borderWidth, borderWidth, d.width-1-2*borderWidth, 
	             d.height-1-2*borderWidth, false);

}

}
