package org.remote.frederik.ziege;
import java.awt.*;

public final class ProgressBar extends Canvas {

	private int max = 0;
	private int val = 0;
	private int percent = 0;
	private int lastpercent = 0;


public void setMax(int max) {

	// Log.msg(Log.GUI|Log.FTRACE, "* ProgressBar.setMax " + max);
	this.max = max;
	lastpercent = -5;
	paint(getGraphics());

}

public void setValue(int val) {

	this.val = val;
	if (max > 0) {
		percent = 100*val/max;
		if (percent > lastpercent) {
			paint(getGraphics());
			lastpercent = percent;
		}
	}
}

public void paint(Graphics g) {

	Dimension s = getSize();
	
	if ((val >= 0) && (max > 0)) {
		int barWidth = (s.width)*val/max;
		String pcs = percent + "%";
		FontMetrics m = getFontMetrics(g.getFont());

		g.setColor(Color.gray);
		g.fillRect(0, 0, barWidth, s.height-1);
		g.clearRect(barWidth, 0, s.width-1, s.height-1);


		g.setColor(Color.black);
		g.drawString(pcs, (s.width - m.stringWidth(pcs)) / 2, 
                        (s.height - m.getHeight()) / 2 + m.getAscent());
	} else {
		g.clearRect(0, 0, s.width-1, s.height-1);
	}

}

public Dimension getMinimumSize() {

	FontMetrics m = getFontMetrics(getFont());
	return(new Dimension(m.stringWidth("100%"), m.getAscent()));

}

public Dimension getPreferredSize() {

	Dimension d = getMinimumSize();
	d.width += 6; if (d.width < 5*d.height) d.width = 5*d.height;
	return(d);

}

}
